<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/
defined('_JEXEC') or die('Restricted access');

$libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
require_once($libpath . 'CrBcAPaymentAdminPlugin.php');
require_once($libpath . 'CrBcPaymentAdminPlugin.php');

class CrBc_Plugins_Payment_Paypal_Admin extends CrBcAPaymentAdminPlugin implements CrBcPaymentAdminPlugin
{
    public function  __construct() {
        
        require_once(JPATH_SITE.'/administrator/components/com_breezingcommerce/classes/CrBcPane.php');
        
        // always call the parent constructor and always call it _first_
        parent::__construct();
        
        // define the default table for built-in list/details view
        $this->table = '#__breezingcommerce_plugin_payment_paypal';
    }
    
    // allow raw for the info through beforeStore overwrite
    public function beforeStore($data){
        
        $test = JRequest::getBool('test_account', false);
        
        if(!$test){
            $data['test_account'] = 0;
        } else {
            $data['test_account'] = 1;
        }
        
        $data['info'] = JRequest::getVar( 'info', '', 'POST', 'STRING', JREQUEST_ALLOWRAW );
        
        return $data;
        
    }
    
    // allow raw for the info_translation through afterStore
    public function afterStore($data){
        
        $data['info_translation'] = JRequest::getVar( 'info_translation', '', 'POST', 'STRING', JREQUEST_ALLOWRAW );
        
        if(isset($data['info_translation']) && $data['info_translation'] != ''){
            $fields = array();
            $fields['body'] = trim($data['info_translation']);
            CrBcHelpers::storeTranslation($fields, $data[$this->identity_column], 'plugin_payment_paypal');
        }
    }

    /**
     * Called on render HTML
     */
    function display(){
        $this->setDetailsView(array('apply', 'cancel'));
    }

    /**
     * Overriden from CrBcAdminPlugin
     * @param array $toolbarItems
     */
    function setDetailsView($toolbarItems = array()){

        $this->setToolbar($toolbarItems);
        $this->template = 'details';

        $db = JFactory::getDBO();
 
        $db->setQuery("Select * From " . $this->table . " Order By `".$this->identity_column."` Desc Limit 1");
        $row = $db->loadObject();

        if(!($row instanceof stdClass)){
            $row = new stdClass();
            $id = $this->identity_column;
            $row->$id = 0;
            $row->info = '';
            $row->test_account = 0;
            $row->business = '';
            $row->token = '';
            $row->cancel_url = '';
            $row->force_locale = '';
            $row->force_currency = '';
            $row->use_ipn = 0;
        }
        
        $id = $this->identity_column;
        $db->setQuery("Select * From #__breezingcommerce_translations Where item_id = ".$row->$id." And type = 'plugin_payment_paypal' And language_code = ".$db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
        $info_translation = $db->loadObject();
        $row->info_translation = '';
        if($info_translation !== null){
            $row->info_translation = $info_translation->body;
        }

        $this->assignRef('entity', $row);
    }

    function init($subject = null){
        // nothing yet
    }

    function getPaymentInfo(){
        $db = JFactory::getDBO();

        $db->setQuery("Select * From " . $this->table . " Order By `".$this->identity_column."` Desc Limit 1");
        $row = $db->loadObject();

        if(!($row instanceof stdClass)){
            $row = new stdClass();
            $row->info = JText::_('COM_BREEZINGCOMMERCE_PAYPAL_NO_INFO');
        }

        return $row->info;
    }

    function getAfterPaymentInfo(){
        return JText::_('COM_BREEZINGCOMMERCE_PAYPAL_INFO_PAID');
    }

    public function getPluginDisplayName(){
        return JText::_('COM_BREEZINGCOMMERCE_PAYPAL');
    }
    
    public function getPluginDescription(){
        return JText::_('COM_BREEZINGCOMMERCE_PAYPAL_DESCRIPTION');
    }
}
